package com.test;

import java.util.HashMap;
import java.util.Map;

import android.widget.Toast;


public aspect Trace {

	void showToast(CharSequence msg) {
        Toast.makeText(HelloAspectJActivity.instance, msg, Toast.LENGTH_SHORT).show();
    }
	
	pointcut testExec() : execution(public void com.test.HelloAspectJActivity.test1());
	
	before(): testExec(){
		showToast("AspectJ: test1() execution...");
	}
	
	pointcut methodCalls(): 
	  execution(* com.test..*(..))&& !within(com.test.Trace);

	Object around() : methodCalls() {
		
		String threadName = Thread.currentThread().getName();
		
		if(null==threadMap.get(threadName)){
			threadMap.put(threadName,0);
		}
		
		int stackDepth = threadMap.get(threadName) + 1;
		
		
		
		threadMap.put(threadName,stackDepth);

		
		String name = Thread.currentThread().getName();
		
		String indent = "";
		
		for (int index = 0; index < stackDepth; index++) {
			indent += "   ";
		}

		System.out.println(name+":"+indent + ">>>>    "
				+ thisJoinPointStaticPart.getSignature().toString());
		
		long start = System.currentTimeMillis();
		try {
			return proceed();
		} finally {

			long end = System.currentTimeMillis();
			
			System.out.println(name+":"+indent + "<<<< "
					+ thisJoinPointStaticPart.getSignature().toString() + "("
					+ (end - start) + " milliseconds)");
			
			threadMap.put(threadName,stackDepth - 1);
		}

	}

	private static Map<String, Integer> threadMap= new HashMap<String,Integer>();

	
}

